export declare type Rule = Readonly<{
    contexts: ReadonlyArray<RegExp>;
    change: Readonly<{
        from: string;
        to: string;
    }>;
    info?: string;
}>;
export declare type StringTransformer = (x: string) => string;
export declare const NO_INFO: null;
export declare function verificationRegexFor(r: Rule): RegExp;
export declare function mistakesRegexFor(r: Rule): RegExp;
export declare type ProofreadingConfig = Readonly<{
    rules: ReadonlyArray<Rule>;
    markWith: (identifier: string) => (info: string | null) => StringTransformer;
    identifiers: Readonly<{
        mistake: string;
        verified: string;
    }>;
}>;
export declare function proofreadWith(c: ProofreadingConfig): StringTransformer;
export declare function highlightWith(c: Readonly<{
    pattern: RegExp;
    mark: StringTransformer;
}>): StringTransformer;
export declare function compose<A, B, C>(f: (b: B) => C, g: (a: A) => B): (a: A) => C;
export declare function join(patterns: ReadonlyArray<RegExp>): RegExp;
