"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const escape_string_regexp_1 = __importDefault(require("escape-string-regexp"));
exports.NO_INFO = null;
function verificationRegexFor(r) {
    return join(r.contexts.map(c => new RegExp(c.source.replace(escape_string_regexp_1.default(r.change.from), r.change.to))));
}
exports.verificationRegexFor = verificationRegexFor;
function mistakesRegexFor(r) {
    return join(r.contexts);
}
exports.mistakesRegexFor = mistakesRegexFor;
function proofreadWith(c) {
    function replacer(mark, substring) {
        const transform = (substring === undefined
            ? mark
            : (s) => s.split(substring).join(mark(substring)));
        return (match, ...rest) => {
            const captured = rest.find(x => x !== undefined);
            return (typeof captured === "string"
                ? match.replace(captured, transform(captured))
                : transform(match));
        };
    }
    const markWith = c.markWith;
    const { mistake, verified } = c.identifiers;
    const transformers = c.rules.map(r => compose((text) => text.replace(verificationRegexFor(r), replacer(markWith(verified)(exports.NO_INFO), r.change.to)), (text) => text.replace(mistakesRegexFor(r), replacer(markWith(mistake)(r.info || exports.NO_INFO), r.change.from))));
    return transformers.reduceRight(compose, x => x);
}
exports.proofreadWith = proofreadWith;
function highlightWith(c) {
    return text => text.replace(c.pattern, c.mark);
}
exports.highlightWith = highlightWith;
function compose(f, g) {
    return x => f(g(x));
}
exports.compose = compose;
function join(patterns) {
    return new RegExp(patterns.map(p => p.source).join("|"), "g");
}
exports.join = join;
//# sourceMappingURL=core.js.map